<template>
    <div>
        <transition name="slide" mode="out-in">
            <ul class="list-unstyled" v-if="$route.name === 'shop'">
                <li class="media" style="margin-top: 20px;" v-for="product of products" :key="product.id">
                    <img :src="`http://localhost:8000/api/images/${product.filename}`"
                         class="mr-3" style="width: 300px; height: 225px"/>
                    <div class="media-body">
                        <div class="d-flex w-100 justify-content-between">
                            <h5 class="mt-0 mb-1">{{product.product_name}}</h5>
                            <small class="text-muted d-block">{{product.posted_date}}</small>
                        </div>
                        <p class="card-text" v-html="product.description"></p>
                        <router-link :to="{ name: 'detail', params: { id: product.id }}"><button class="btn btn-primary">Details</button></router-link>
                    </div>
                </li>
            </ul>
        </transition>
        <transition name="slide" mode="out-in">
            <router-view></router-view>
        </transition>
    </div>
</template>

<script>
    import axios from 'axios';
    export default {
        data() {
            return {
                products: []
            }
        },
        beforeRouteEnter(to, from, next) {
            axios.get('http://localhost:8000/api/getProducts.php')
                .then((res) => {
                    next(vm => vm.products = res.data)
                }).catch((err) => {
                console.log(err);
            });
        },
        beforeRouteUpdate(to, from, next) {
            if(to.path === '/shop' && from.path === '/shop/add'){
                this.products = [];
                axios.get('http://localhost:8000/api/getProducts.php').then(res => {
                        this.setData(res.data);
                        next();
                    },
                    err => console.log(err)
                )
            }
            next();
        },
        methods: {
            setData(product) {
                this.products = product;
            }
        }
    }
</script>